#include <errno.h>
#include <sys/types.h>
#include "proto.h"
#include "struct.h"
#include "extern.h"

//*****************************************************************************
// chmod_msg - Change permissions of driver.
//*****************************************************************************
int chmod_msg(pid_t pid)
{
   struct ocb *ocb;
   uid_t uid;
   gid_t gid;
   
   if ((ocb = get_ocb(pid, io_msg.chmod.fd)) == -1)
   {
      io_msg.status = EBADF;
      return(REPLY);
   }
                     // Get group and user id of calling process.
   get_ids( pid, &uid, &gid );
   if( uid == 0  ||  uid == das_stat.st_uid) 
   {
      /*
       * ROOT  anytime
       * OWNER anytime
       * GROUP never
       * OTHER never
       */
      das_stat.st_mode = das_stat.st_mode & ~0777 | (io_msg.chmod.mode & 0777) ;   /* Change access modes. */
      das_stat.st_ctime = *timep;   // Time of last status change.
      io_msg.status = EOK;
   }
   else
      io_msg.status = EACCES;
   return(REPLY);
}
