#include <errno.h>
#include <sys/types.h>
#include "struct.h"
#include "extern.h"
#include "proto.h"

//*****************************************************************************
// chown_msg - Change the owner of the driver.
//*****************************************************************************
int chown_msg(pid_t pid)
{
   uid_t uid;
   gid_t gid;
   struct ocb  *ocb;

   if ((ocb = get_ocb(pid, io_msg.chown.fd)) == -1)
   {
      io_msg.status = EBADF;
      return(REPLY);
   }
                     // Get group and user id of calling process.
   get_ids( pid, &uid, &gid );
      /*
       * ROOT  anytime
       * OWNER (can change group, but not owner)
       * GROUP never
       * OTHER never
       */
   if(uid == 0  ||  (uid == das_stat.st_uid  &&  
        io_msg.chown.uid == das_stat.st_uid))
   {
      das_stat.st_uid = io_msg.chown.uid;    // Change user ID.  
      das_stat.st_gid = io_msg.chown.gid;    // Change group ID. 
      das_stat.st_ctime = *timep;            // Time of last status change.
      io_msg.status = EOK;
   }
   else
      io_msg.status = EACCES;
   return(REPLY);
}
