#include <stdlib.h>
#include <malloc.h>
#include <errno.h>
#include <fcntl.h>
#include <das.h>
#include "define.h"
#include "struct.h"
#include "extern.h"
#include "proto.h"

//*****************************************************************************
// close_msg - Remove driver access from calling proces.
//*****************************************************************************
int close_msg(pid_t pid)
{
   struct ocb  *ocb;
   
   if ((ocb = get_ocb(pid, io_msg.close.fd)) == -1)
   {
      io_msg.status = EBADF;
      return(REPLY);
   }
   ocb->count--;
   if (in_use == SINGLE_USER)
   {
      das_ad_term(das_fd, 0);
      das_da_term(das_fd, 0);
      in_use = NO_USERS;
   }
   else
      if (--in_use == 0)
         das_stop_dma();
   
   if(ocb->count == 0)   // Allow another application to use the driver. 
   {
              // Free any memory used by A/D requests.
      if (ocb->req_t == A_D)  
         das_ad_term_msg(pid);
      else if (ocb->req_t == D_A)
         das_da_term_msg(pid);
   }
   das_free_msg(pid);
   free(ocb);
   map_ocb(pid, io_msg.close.fd, NULL);
   io_msg.close_reply.status = EOK;
   return(REPLY);
}
