#include <errno.h>
#include <sys/types.h>
#include "struct.h"
#include "extern.h"
#include "proto.h"

//*****************************************************************************
// dup_msg -   Dupicate a file discriptor.
//*****************************************************************************
int dup_msg(pid_t pid)
{
   struct ocb *ocb;
   
                     // Get OCB 
   if ((ocb = get_ocb(io_msg.dup.src_pid ? io_msg.dup.src_pid : 
                     pid, io_msg.dup.src_fd)) == -1)
   {  
      io_msg.status = EBADF;
      return(REPLY);
   }
                     // Map OCB to new FD.
   if (map_ocb(pid, io_msg.dup.dst_fd, ocb) == -1)
   {
      io_msg.status = errno;
      return(REPLY);
   }
   
	ocb->count++;     // Signify that another FD has this OCB.
	io_msg.dup_reply.status = EOK;
	return(REPLY);
}
