#include <stdlib.h>
#include "struct.h"
#include "proto.h"
#include "extern.h"

//*****************************************************************************
// handle_msg -   Similar to open except it is call instead when a function
//                does not require an FD (a path is used ie. chmod()).
//*****************************************************************************
int handle_msg(pid_t pid)
{
   uid_t uid;
   gid_t gid;
   struct ocb  *ocb;

   get_ids(pid, &uid, &gid);         // Get egid and euid of process pid.
   io_msg.status = EOK;

   switch(io_msg.open.oflag)
   {
      case _IO_HNDL_CHANGE: // Used by chmod(), chown()... NOT fchmod/own. 
                     
                     // Must be super user or have equivalent euid.
         if (uid != 0 && uid != das_stat.st_uid)
         {
            io_msg.status = EPERM;
            break;
         }
         if ((ocb = (struct ocb *)calloc(1, sizeof(struct ocb))) == NULL)
         {
            io_msg.status = errno;
            return(REPLY);
         }
         if(map_ocb(pid, io_msg.open.fd, ocb) == -1)
            io_msg.status = errno;
         else
		 {
            ocb->count++;
			in_use++;
		 }
         break;

      case _IO_HNDL_INFO:   // Used by OLD stat(), pathconf(), fullpath().
      case _IO_HNDL_UTIME:  // Used by utime()... NOT _futime().

         if((check_access(pid, &das_stat) & S_IRWXU) == 0)
         {
            io_msg.status = EPERM;
            break;
         }
         if ((ocb = (struct ocb *)calloc(1, sizeof(struct ocb))) == NULL)
         {
            io_msg.status = errno;
            return(REPLY);
         }
         if(map_ocb(pid, io_msg.open.fd, ocb) == -1)
            io_msg.status = errno;
         else
		 {
            ocb->count++;
			in_use++;
		 }
         break;

      case _IO_HNDL_RDDIR:
      case _IO_HNDL_LOAD:
      case _IO_HNDL_CLOAD:
         io_msg.status = ENOSYS;
         break;
   }
   return(REPLY);
}

