#include <string.h>
#include <sys/types.h>
#include "define.h"
#include "struct.h"
#include "proto.h"
#include "extern.h"

//*****************************************************************************
// fstat_msg - Return the stat structure to the calling process (FD required).
//*****************************************************************************
int fstat_msg(pid_t pid)
{
   struct ocb  *ocb;
   
   if((ocb = get_ocb(pid, io_msg.fstat.fd)) == -1)
   {
      io_msg.status = EBADF;
      return(REPLY);
   }
   memcpy(&io_msg.fstat_reply.stat, &das_stat, sizeof(struct stat));
   io_msg.status = EOK;
   return(NO_REPLY);
}
//*****************************************************************************
// stat_msg -  Return the stat structure to the calling process 
//             (FD not required).
//*****************************************************************************
#pragma off (unreferenced)
int stat_msg(pid_t pid)
{
   
   if(io_msg.open.path[0]  == NULL)
      memcpy(&io_msg.fstat_reply.stat, &das_stat, sizeof(struct stat));
   else
   {
      io_msg.status = ENOENT;
      return(REPLY);
   }
   io_msg.status = EOK;
   return(REPLY);
}
#pragma on (unreferenced)
