#include <sys/sendmx.h>
#include <sys/kernel.h>
#include "struct.h"
#include "extern.h"

//*****************************************************************************
// sys_msg -   Respond to system message - VERSION message is only supported
//*****************************************************************************
int sys_msg(pid_t pid)
{
   int reply;
   struct _sysmsg_version_reply version = { "Das", __DATE__, 101, 'A', 0 };
   struct _mxfer_entry mx[2];

   switch(io_msg.sysmsg.subtype)
   {
                           // Reply with the driver version.
      case _SYSMSG_SUBTYPE_VERSION: 
         io_msg.sysmsg_reply.status = EOK;
         _setmx(&mx[0], &io_msg, sizeof(io_msg.sysmsg_reply));
         _setmx(&mx[1], &version, sizeof(version));
         Replymx(pid, 2, &mx);
         reply = NO_REPLY;
         break;

                     // The following system messages are not supported by 
                     // this driver.
      case _SYSMSG_SUBTYPE_DEATH:
      case _SYSMSG_SUBTYPE_SIGNAL:
      case _SYSMSG_SUBTYPE_TRACE:
         io_msg.sysmsg_reply.status = ENOSYS;
         reply = REPLY;
         break;
   }
   return(reply);
}
