#include <sys/fd.h>
#include "proto.h"
#include "struct.h"
#include "define.h"
#include "extern.h"

//*****************************************************************************
// utime_msg - Change the access time on the driver. 
//*****************************************************************************
int utime_msg(pid_t pid)
{
   struct ocb  *ocb;
   
   if ((ocb = get_ocb(pid, io_msg.utime.fd)) == -1)
   {
      io_msg.status = EBADF;
      return(REPLY);
   }
                     // Calling process must have write permission. 
   if((das_stat.st_mode & S_IWRITE) == 0)
   {
      io_msg.utime_reply.status = EBADF;
      return(REPLY);
   }
                        // Set to current time. 
   if(io_msg.utime.cur_flag)
   {
      das_stat.st_atime = *timep;
      das_stat.st_mtime = *timep;
      io_msg.fstat_reply.stat.st_atime = *timep;
      io_msg.fstat_reply.stat.st_mtime = *timep;
   }
   else              // Set to time passed with message.
   {
      das_stat.st_mtime = io_msg.utime.modtime;
      das_stat.st_atime = io_msg.utime.actime;
      io_msg.fstat_reply.stat.st_mtime = io_msg.utime.modtime;
      io_msg.fstat_reply.stat.st_atime = io_msg.utime.actime;
   }
   io_msg.utime_reply.status = EOK;
   return(REPLY);
}
