#ifndef _DAS_PROTO

#include "struct.h"

extern void das_init(int argc, char *argv[]);
extern void terminate(void);

extern int handle_msg(pid_t pid);
extern int chmod_msg(pid_t pid);
extern int open_msg(pid_t pid);
extern int close_msg(pid_t pid);
extern int chown_msg(pid_t pid);
extern int sys_msg(pid_t pid);
extern int stat_msg(pid_t pid);
extern int fstat_msg(pid_t pid);
extern int dup_msg(pid_t pid);
extern int utime_msg(pid_t pid);

extern int das_query_msg(pid_t pid);
extern int das_alloc_msg(pid_t pid);
extern int das_free_msg(pid_t pid);

extern int das_ad_sync_msg(pid_t pid);
extern int das_ad_enqueue_msg(pid_t pid);
extern int das_ad_read_msg(pid_t pid);
extern int das_ad_term_msg(pid_t pid);
extern int das_ad_set_scan_msg(pid_t pid);
extern int das_ad_sam_msg(pid_t pid);
extern int das_ad_set_trig_msg(pid_t pid);
extern int das_ad_get_trig_msg(pid_t pid);
extern int das_ad_get_rng_msg(pid_t pid);
extern int das_ad_set_rng_msg(pid_t pid);
extern int das_ad_get_que_msg(pid_t pid);

extern int das_da_sync_msg(pid_t pid);
extern int das_da_enqueue_msg(pid_t pid);
extern int das_da_wait_msg(pid_t pid);
extern int das_da_term_msg(pid_t pid);
extern int das_da_sam_msg(pid_t pid);
extern int das_da_set_trig_msg(pid_t pid);
extern int das_da_get_trig_msg(pid_t pid);
extern int das_da_get_rng_msg(pid_t pid);
extern int das_da_set_rng_msg(pid_t pid);
extern int das_da_wait_msg(pid_t);
extern int das_da_get_que_msg(pid_t pid);

extern int das_dig_in_msg(pid_t pid);
extern int das_dig_out_msg(pid_t pid);

extern int das_add_tick_list(struct ocb *ocb, long ticks);
struct ocb * das_rm_tick_list(int t_id);
extern int get_time_list_id(void);

extern void das_start_dma(void);
extern void das_stop_dma(void);
extern void das_reinit(void);

extern struct das_res_queue * das_res_create_entry(void);
extern void das_res_unlink(int op, struct das_res_queue **hptr, 
                        struct das_res_queue **tptr);
extern int das_res_link(struct das_res_queue *ptr, struct das_res_queue **hptr, 
                        struct das_res_queue **tptr);

extern int das_res_int(void);

extern int das_get_conversion(void);
extern void das_put_da_sample(struct ocb *ocb);
extern void das_get_ad_sample(struct ocb *ocb);

extern int excl_das_ad_enqueue_msg(struct ocb *ocb);
extern int excl_das_da_enqueue_msg(struct ocb *ocb);
extern void excl_ad_proxy_msg(void);
extern void excl_da_proxy_msg(void);

extern mode_t check_access(pid_t pid, struct stat *sptr);
extern void get_ids(pid_t pid, uid_t *uid, gid_t *gid);
extern int map_ocb(pid_t pid, int fd, struct ocb *ocb);
extern struct ocb * get_ocb(pid_t pid, int fd);

extern struct das_mem_que * das_get_buf(struct ocb *ocb);
extern void das_rel_buf(struct das_mem_que *que, struct ocb *ocb);

#define _DAS_PROTO
#endif
