   #include <stdio.h>
   #include <stdlib.h>
   #include <fcntl.h>
   #include <das.h>

   #define  VDIV  1000000L
   
   struct   ranges
   {
      long  rmin;
      long  rmax;
   };

   struct ranges rng[11] = {
             {         0, 10000000 },        //    0V - 10V
             {         0,  5000000 },        //    0V - 5V
             {         0,  2000000 },        //    0V - 2V
             {         0,  1000000 },        //    0V - 1V
             {         0,   100000 },        //    0V - 100mV
             { -10000000, 10000000 },        //  -10V - 10V
             {  -5000000,  5000000 },        //   -5V - 5V
             {  -2500000,  2500000 },        // -2.5V - 2.5V
             {  -1000000,  1000000 },        //   -1V - 1V
             {   -500000,   500000 },        // -0.5V - 0.5V
             {    -50000,    50000  } };     // -50mV - 50mV
   
   void main()
   {
      char buf[9], chnl, range;
      int fd;

      /* open the 'das' resource manager/library            */
      if ((fd = das_open("/dev/das", O_RDWR)) == -1)
      {
         perror("das_open");
         exit(-1);
      }

      printf("das_da_set_range()\n");   
      printf("0  >   0 to +10V\n");
      printf("1  >   0 to +5V\n");
      printf("2  >   0 to +2V\n");
      printf("3  >   0 to +1V\n");
      printf("4  >   0 to 100mV\n");
      printf("5  >   +-10V\n");
      printf("6  >   +-5V\n");
      printf("7  >   +-2.5V\n");
      printf("8  >   +-1V\n");
      printf("9  >   +-0.5V\n");
      printf("10 >   +-50mV\n");

      printf("Enter channel # :> ");
      chnl = atoi(fgets(buf, sizeof(buf), stdin));
      printf("Enter range :> ");
      range = atoi(fgets(buf, sizeof(buf), stdin));
      if (das_da_set_range(fd, chnl, rng[range].rmin, rng[range].rmax) == -1)
         perror("das_da_set_range");
      else
         printf("Range for channel %hx has been set to %ld to %ldV\n",
                           chnl, rng[range].rmin/VDIV, rng[range].rmax/VDIV);
      
      /* close the resource manage/library         */
      if (das_close(fd) == -1)
         perror("das_close");
   }
