   #include <stdio.h>
   #include <stdlib.h>
   #include <fcntl.h>
   #include <das.h>
   
   void main()
   {
      int fd;
      long dig_ival, dig_oval = 0xAA;

      /* open the 'das' resource manager/library   */
      /* for analog to digital conversions         */
      if ((fd = das_open("/dev/das", O_RDWR)) == -1)
      {
         perror("das_open");
         exit(-1);
      }

      /* read the levels on digital input port 0   */
      if (das_digital_in(fd, 0, &dig_ival) == -1)
         perror("das_digital_in -> port 0");
      printf("input from port 0 -> %#04x\n",dig_ival);

      /* output 'dig_oval' to port 0                  */
      printf("output %#04x to port 0\n",dig_oval);
      if (das_digital_out(fd, 0, dig_oval, 0xFFFFFFFF, NULL, NULL) == -1)
         perror("das_digital_out ->port 0");

      /* close the resource manager          */ 
      if (das_close(fd) == -1)
         perror("das_close");
   }
