   #include <stdio.h>
   #include <stdlib.h>
   #include <fcntl.h>
   #include <das.h>
   
   void main()
   {
      das_info info;
      int fd;

      /* open the 'das' resource manager/library            */
      if ((fd = das_open("/dev/das", O_RDWR)) == -1)
      {
         perror("das_open");
         exit(EXIT_FAILURE);
      }
      
      /* Get information on the adapter configuration       */
      if (das_get_info(fd, &info) == -1)
      {
         perror("das_get_info");
         exit(EXIT_FAILURE);
      }
      
      printf("Base address is:  %x\n", info.port);
      printf("IRQ is:  %x\n", info.irq);
      printf("DMA channel is:  %x\n", info.dma_chnl);
      if(info.range_ctrl == DAS_LOCAL)
         printf("Range is controlled by switch settings\n");
      else
         printf("Range is controlled with software\n");
      if(info.chnl_cnfg == DAS_SINGLE_ENDED)
         printf("A/D channel configuration is 16 channel single-ended input\n");
      else
         printf("A/D channel configuration is 8 channel differential input\n");
      printf("Pacer clock frequency is:  %ld Hz\n", info.pace_clk);

      /* close the resource manager/library                 */
      das_close(fd);
   }
