   #include <stdio.h>
   #include <stdlib.h>
   #include <fcntl.h>
   #include <das.h>
   
   void main()
   {
      int fd;
      das_t ad_data;

      /* open the 'das' resource manager/library      */
      if ((fd = das_open("/dev/das", O_RDONLY)) == -1)
      {
         perror("das_open");
         exit(EXIT_FAILURE);
      }

      /* perform a single A/D conversion on channel 0 */    
      if (das_ad_sync(fd, 0, &ad_data) == -1)
      {
         perror("das_ad_sync");
         exit(EXIT_FAILURE);
      }
      
      printf("A/D channel %hx data is: %hx\n", (ad_data & 0x0F), ad_data >> 4);

      /* close the resource manager/library           */ 
      if (das_close(fd) == -1)
      {
         perror("das_close");
         exit(EXIT_FAILURE);
      }
   }
