#include <sys/types.h>
/*
 * das_dma.h: manifests and structures
 */

#ifndef  _DMA_T_DEFINED
/*
 * structure for dma io, maintains logical-physical mapping
 */
struct   dma_buffer {
   caddr_t bufp;        /* logical address   */
   paddr_t phys_addr;      /* physical address  */
};

#define  _DMA_T_DEFINED
typedef  struct dma_buffer dma_t;
#endif

/*
 * flags for dma io routines
 * DMA_OUTPUT = input or output.
 * PS/2 dma   = uses micro-channel dma
 * DMA_WORD   = 16 bit vs 8 bit dma
 * DMA_WAIT   = for setup_dma, set parameters, but do not arm the controller
 *              (controller may be armed with kick_dma)
 */
#define  DMA_OUTPUT  001
/* ps2 / at */
#define  DMA_PS2     002
/* word / byte */
#define  DMA_WORD 004
/* don't arm dma controller on setup */
#define  DMA_WAIT 010
#define  DMA_AUTO 020         // program the controller for autoinitialize

extern int setup_dma(unsigned dma_flags, dma_t *dbuf, unsigned iosize, int channel);
extern int kick_dma(unsigned dma_flags, int channel);
extern int clear_dma(unsigned dma_flags, int channel);
extern int read_dma(unsigned dflags, int channel);
