// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// das_extern.h contains prototypes and variable for the library
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#include <sys/types.h>
#include <das.h>
#include <das_struct.h>
#include <das_tmr.h>
#include <das_types.h>

extern   int int_id;                   // interrupt id
extern   int _das_fd;                  // file descriptor from system
extern   int init_flag;                // flay to indicate library initialization
extern   struct   das_scan dscan;      // scan queue for pcl-818 and das-20
extern   volatile struct docb docb;    // control structure for adapter
extern   volatile das_t das_res_buf[16];  // used by acquisition mandager
               // at interrupt time, data from DMA buffer is copied into it.

extern   pid_t far das_handler();
extern   struct das_queue * das_create_entry(void);
extern   struct das_queue * das_unlink(int op, struct das_queue **hptr, struct das_queue **tptr);
extern   int das_link(struct das_queue *ptr, struct das_queue **hptr, struct das_queue **tptr);
extern   int das_res_read(int fd, int chnl);

extern   void das_ad_cmd(int chnl);
extern   int das_chk_init_fd(int fd);
extern   void das_da_cmd(int chnl);
extern   void das_catch_sig();
extern   void das_terminate();
extern   int das_set_mux(int mode, int chnl);
extern   int das_ad_request(int fd, int chnl, das_buf_t *buf, int nbytes, int mode, pid_t proxy);
extern   int das_da_request(int fd, int chnl, das_buf_t *buf, int nbytes, int mode, pid_t proxy);

// Counter/Timer routines
extern   int das_ct_mode(int fd, int n_ctr, cntr_mdr_t *cptr, int clk_src);
extern   int das_ct_status(int fd, int n_ctr, int *status);
extern   int das_ct_read(int fd, int n_ctr, int *cnt);
extern   int das_ct_write(int fd, int n_ctr, cntr_t *cptr);
extern   int das_ct_stop(int fd, int n_ctr);
extern   void das_point_to(int chnl, int reg);
extern   int das_set_master(int fd, cntr_mmdr_t *md);
extern   int das_ctr_cmd(int ctr, int cmd);
extern   int das_convert_rate(unsigned long ticks, struct das_rate *sptr);

extern   pid_t das_get_ad_proxy();
extern   pid_t das_get_da_proxy();
