// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// das_inline.h contains pragma's for copying data and enable/
// disable interrupts
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#ifdef __386__

das_memcpy8(void *dst, const void *src, int nbytes);
#pragma aux das_memcpy8 = "push ds" "cld" "pop es" "rep movsb"\
   parm [edi] [esi] [ecx] modify [es ecx edi];

das_memcpy16(void *dst, const void *src, int nbytes);
#pragma aux das_memcpy16 = "push ds" "cld" "pop es" "shr ecx,1" "rep movsw"\
   parm [edi] [esi] [ecx] modify [es ecx edi];

void  delay_8X(unsigned count);
#pragma aux delay_8X = "here: loop here"\
   parm [ecx] modify [ecx];

unsigned disable(void);
#pragma aux disable = "pushfd" "cli" "pop eax"\
   parm [] modify [eax];

void restore(unsigned flgs);
#pragma aux restore = "push eax" "popfd"\
   parm [eax] modify [];

#else

das_memcpy8(void far *dst, const void far *src, int nbytes);
#pragma aux das_memcpy8 =\
   0x1e     /* push ds  */ \
   0x8e 0xda   /*  mov ds,dx */ \
   0xf3 0xa4   /* rep movsb */ \
   0x1f     /* pop ds */ \
   parm nomemory [es di] [dx si] [cx] \
   modify exact [si di cx];

das_memcpy16(void far *a, const void far *b, int nbytes);
#pragma aux das_memcpy16 = \
   0x1e     /* push ds  */ \
   0x8e 0xda   /*  mov ds,dx */ \
   0xc1 0xe9 0x01    /* shr cx,1 */ \
   0xf3 0xa5   /* rep movsw */      \
   0x1f     /* pop ds */ \
   parm nomemory [es di] [dx si] [cx] \
   modify exact [si di cx];

void  delay_8X(unsigned count);
#pragma aux delay_8X =        \
      0xe2 0xfe   /* loop -2  */    \
      parm nomemory [cx]   \
      modify exact nomemory [cx];

unsigned disable(void);
#pragma aux disable = \
      0x9c  /* pushf */ \
      0xfa  /* cli      */ \
      0x58  /* pop ax  */ \
      parm []     \
      modify exact [ AX ];

void restore(unsigned psw);
#pragma  aux   restore = \
      0x50  /* push  ax */ \
      0x9d  /* popf     */ \
      parm [ AX ]                   \
      modify exact [];
   
#endif