// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// das_types.h contains the data types for the acquisition library.
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#ifndef __DAS_TYPES_H_INCLUDED
#include <sys/types.h>
#include <das_dma.h>

#define  _MET_DAS_20       0x00
#define  _PCL_818          0x01

// das_info structure for das_get_info()
typedef struct
{
   short int      port;             // base address of adapter
   short int      irq;              // interrupt request line (2 - 7)
   short int      dma_chnl;         // DMA channel (1 or 3) 
   short int      range_ctrl;       // local vs remote range control (PCL 818)
   short int      chnl_cnfg;        // channel config single ended or diff
   unsigned long  pace_clk;         // pacer clock freq. in Hz.
   short int      ad_res;           // A/D converter resolution
   short int      da_res;           // D/A converter resolution
} das_info;

typedef struct
{
   caddr_t     bufp;                      // logical address
   dma_t       dma;
   unsigned    sel;                       // selector
} das_buf_t;

#define __DAS_TYPES_H_INCLUDED
#endif
