// Metrabyte DAS-20 adapter
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// das_digio.c module contains routines to:
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//    output a value to a port         - das_dig_out()
//    input a value from a port        - das_dig_in()
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#include <errno.h>
#include <conio.h>
#include <met_20.h>
#include <das_struct.h>
#include <das_extern.h>

// Function das_digital_out outputs a byte to an output port.  If the port
// number is out of range the function will return with an error.
int das_digital_out(int fd, int port, long bits, long mask, long *old_bits, long *new_bits)
{
   if(das_chk_init_fd(fd) != EOK)
      return(-1);
   if(port >= NUM_OPORTS)
   {
      errno = EINVAL;
      return(-1);
   }
   if(old_bits)
      *old_bits = docb.dout[port].bits;

   docb.dout[port].bits = (docb.dout[port].bits & ~mask) | (bits & mask);
      
   if(new_bits)
      *new_bits = docb.dout[port].bits;
   outp(docb.info.port + docb.dout[port].addr, docb.dout[port].bits);
   return(EOK);
}

// Function das_digital_in returns the current level of the input port.  If
// the port number is out of range the function will return with an error.
int das_digital_in(int fd, int port, long *bits)
{
   if(das_chk_init_fd(fd) != EOK)
      return(-1);
   if(port >= NUM_IPORTS)
   {
      errno = EINVAL;
      return(-1);
   }
   *bits = inp(docb.info.port + docb.din[port].addr);
   return(EOK);
}
